<?php

/**
 * WooThemes Media Library-driven AJAX File Uploader Module (2010-11-05)
 *
 * Slightly modified for use in the Options Framework.
 */

if(is_admin()){
	$of_page= 'appearance_page_options-framework';
	add_action('wp_ajax_plupload_action', "optionsframework_plupload_action");
}

/**
 * アップロード処理
 */

function optionsframework_plupload_action(){

    $imgid = $_POST["imgid"];
	
    check_ajax_referer($imgid.'pluploadan');
	
	$file = $_FILES[$imgid.'async-upload'];	
	
    $status = wp_handle_upload($_FILES[$imgid.'async-upload'], array('test_form' => true, 'action' => 'plupload_action'));
	
	$filename = $_FILES[$imgid.'async-upload']['name'];
	
	//Adds file as attachment to WordPress
	
  $attach_id = wp_insert_attachment( array(
     'post_mime_type' => $status['type'],
     'post_title' => preg_replace('/\.[^.]+$/','',basename($file['name'])),
     'post_content' => '',
     'post_status' => 'inherit'
  ), $status['file']);

	$image_arg['attachmentID'] = $attach_id;  
 	$attach_data = wp_generate_attachment_metadata($attach_id,$status['file']);	
	wp_update_attachment_metadata( $attach_id, $attach_data);
	
	//*** 既に存在する場合は削除 *** //
	
	if(of_get_option($imgid)){	
		wp_delete_attachment($imgid);	
	}
	
	$upload_image = wp_get_attachment_image_src(esc_attr($attach_id),array(300,300),false);
	

	$image_arg['imageURL'] = $upload_image[0];
	
	echo json_encode($image_arg);
	
   exit;
}



if ( ! function_exists( 'optionsframework_medialibrary_uploader' ) ) :

function optionsframework_medialibrary_uploader( $_id, $_value, $_mode = 'full', $_desc = '', $_postid = 0, $_name = '',$_array = '') {

	$optionsframework_settings = get_option('optionsframework');
	
	// Gets the unique option id
	$option_name = $optionsframework_settings['id'];
	
	$output = '';
	$id = '';
	$class = '';
	$int = '';
	$value = '';
	$name = '';
	$multiple_tag = "";
	
	$id = strip_tags(strtolower($_id[0]));
	
	
	// Change for each field, using a "silent" post. If no post is present, one will be created.
	$int = optionsframework_mlu_get_silentpost($id);
	
	// If a value is passed and we don't have a stored value, use the value that's passed through.
	if ( $_value != '' && $value == '' ) {
		$value = $_value;
	}
	
	if($_name != '' && !is_null($_array)){
	
		$formID = $_id."_".$_array;
		$formname = $option_name.'['.$_id.']['.$_array.']['.$_name.']';		
		$value = $value;
		
	}elseif($_name == '' && $_id['child']){
				
		$formID = $_id['child'];
		$formname = $option_name."[".$_id[0]."][".$_id['child']."]";
	
	}elseif($_name == '' && !$_id['child']){
		
		$formID = $_id[0];
		$formname = $option_name."[".$_id[0]."]";
		
	}
	
/*	if ($_name != '' && is_null($_array)) {
	
		$name = $option_name.'['.$id.']['.$_name.']';		
		$value = $value;
		
	}elseif($_name != '' && !is_null($_array)){
	
		$name = $option_name.'['.$id.']['.$_array.']['.$_name.']';		
		$value = $value;		
		$id = $id."_".$_array;
		
	}else {
	
		$name = $option_name.'['.$id.']';
	}*/
	
	if ( $value ) { $class = ' has-file'; }

	//imageuploader
	
	
	if($multiple){ $multiple_tag = "plupload-upload-uic-multiple"; }
	
	$output .= "<div class=\"plupload-upload-uic hide-if-no-js {$multiple_tag}\" id=\"".$formID."plupload-upload-ui\">\n";
	$output .= "<span class=\"ajaxnonceplu\" id=\"ajaxnonceplu".wp_create_nonce($formID.'pluploadan')."\"></span>\n";
    
	if($width && $height){
	
            $output .= "<span class=\"plupload-resize\"></span>\n";
			$output .= "<span class=\"plupload-width\" id=\"plupload-width".$width."\"></span>\n";
            $output .= "<span class=\"plupload-height\" id=\"plupload-height".$height."\"></span>\n";
    }

    $output .= "<div class=\"filelist\"></div>\n";
		
	if($multiple){ $multiple_thumb_tag = "plupload-thumbs-multiple"; }
	

	//if(of_get_option($id)){
			
		//** 画像を300x400に縮小 **//
		
		$image_src = wp_get_attachment_image_src(esc_attr($value), $_mode,false);
	
		$output .= "<div class=\"thumb\" id=\"thumb_".$formID."\">\n";
		
		if($image_src){
		
			$output .= "<img src=\"".$image_src[0]."?".date('is')."\" alt=\"".$formID."\" id=\"".$formID."_thumb\" />\n";
		
		}else{
		
			$output .= "<img src=\"".OPTIONS_FRAMEWORK_DIRECTORY."/images/noimage.png\" id=\"".$formID."_thumb\" alt=\"".$formID."\" />\n";
		}
		
		$output .= "</div>\n";
		
		$output .= "<div class=\"plupload-thumbs {$multiple_thumb_tag}\" id=\"".$formID."plupload-thumbs\"></div>\n";
		
		$output .= "<div class=\"thumbi\">\n";
		
		$output .= "<input id=\"".esc_attr($formID)."\" class=\"of-input hidden_form\" name=\"".esc_attr($formname)."\" type=\"hidden\" value=\"".esc_attr($value)."\" />\n";
		
		if(!$value){
			$image_style = "style=\"display:none;\"";
		}
				
		//** アップロード **//
		$output .= "<input id=\"".esc_attr($formID)."plupload-browse-button\" type=\"button\" value=\"".__('画像をアップロード')."\" class=\"image-uploader-button button\" data-form-id=\"".esc_attr($formID)."\" />&nbsp;";
		
		$output .= "<a href=\"".admin_url('post.php')."?post=".esc_attr($value)."&action=edit&amp;image-editor&amp;cp4imageedit=true&amp;height=600&amp;width=700&amp;image_class=".esc_attr($id)."&amp;TB_iframe=1\" class=\"button-primary thickbox\" title=\"".__('media edit')."\" ".$image_style." >".__('画像を編集')."</a>&nbsp;";
		
		//** 削除リンク**//
				
		$output .= "<a class=\"thumb_remove_link button-primary\" href=\"javascript:void(0);\" ".$image_style." >".__( '画像を削除')."</a>\n";		
		$output .= "<div class=\"clear\"></div>";
		$output .= "</div>";		
		$output .= "</div>";
		
    //imageuploader end
	
	if ( $_desc != '' ) {
		$output .= '<span class="of_metabox_desc">' . $_desc . '</span>' . "\n";
	}
	
	//$output .= '<div class="screenshot" id="' . $id . '_image">' . "\n";
	
	if ( $value != '' ){
		$remove = '<a href="javascript:(void);" class="mlu_remove button">Remove</a>';
		$image = preg_match( '/(^.*\.jpg|jpeg|png|gif|ico*)/i', $value);
		if ( $image ) {
			$output .= '<img src="'.$value.'" alt="" />'.$remove.'';
		}else{
			$parts = explode( "/", $value );
			for( $i = 0; $i < sizeof( $parts ); ++$i ){
				$title = $parts[$i];
			}

			// No output preview if it's not an image.			
			$output .= '';
		
			// Standard generic output if it's not an image.	
			$title = __( 'View File', 'options_framework_theme' );
			//$output .= '<div class="no_image"><span class="file_link"><a href="' . $value . '" target="_blank" rel="external">'.$title.'</a></span>' . $remove . '</div>';
		}	
	}
	//$output .= '</div>' . "\n";
	return $output;
}

endif;

/**
 * Uses "silent" posts in the database to store relationships for images.
 * This also creates the facility to collect galleries of, for example, logo images.
 * 
 * Return: $_postid.
 *
 * If no "silent" post is present, one will be created with the type "optionsframework"
 * and the post_name of "of-$_token".
 *
 * Example Usage:
 * optionsframework_mlu_get_silentpost ( 'of_logo' );
 */

if ( ! function_exists( 'optionsframework_mlu_get_silentpost' ) ) :

function optionsframework_mlu_get_silentpost ( $_token ) {

	global $wpdb;
	$_id = 0;

	// Check if the token is valid against a whitelist.
	// $_whitelist = array( 'of_logo', 'of_custom_favicon', 'of_ad_top_image' );
	// Sanitise the token.
	
	$_token = strtolower( str_replace( ' ', '_', $_token ) );
	
	// if ( in_array( $_token, $_whitelist ) ) {
	if ( $_token ) {
		
		// Tell the function what to look for in a post.
		
		$_args = array( 'post_type' => 'optionsframework', 'post_name' => 'of-' . $_token, 'post_status' => 'draft', 'comment_status' => 'closed', 'ping_status' => 'closed' );
		
		// Look in the database for a "silent" post that meets our criteria.
		$query = 'SELECT ID FROM ' . $wpdb->posts . ' WHERE post_parent = 0';
		foreach ( $_args as $k => $v ) {
			$query .= ' AND ' . $k . ' = "' . $v . '"';
		} // End FOREACH Loop
		
		$query .= ' LIMIT 1';
		$_posts = $wpdb->get_row( $query );
		
		// If we've got a post, loop through and get it's ID.
		if ( count( $_posts ) ) {
			$_id = $_posts->ID;
		} else {
		
			// If no post is present, insert one.
			// Prepare some additional data to go with the post insertion.
			$_words = explode( '_', $_token );
			$_title = join( ' ', $_words );
			$_title = ucwords( $_title );
			$_post_data = array( 'post_title' => $_title );
			$_post_data = array_merge( $_post_data, $_args );
			$_id = wp_insert_post( $_post_data );
		}	
	}
	return $_id;
}
endif;

/**
 * Trigger code inside the Media Library popup.
 */

if ( ! function_exists( 'optionsframework_mlu_insidepopup' ) ) :
function optionsframework_mlu_insidepopup () {

	if ( isset( $_REQUEST['is_optionsframework'] ) && $_REQUEST['is_optionsframework'] == 'yes' ) {
	
		add_action( 'admin_head', 'optionsframework_mlu_js_popup' );
		add_filter( 'media_upload_tabs', 'optionsframework_mlu_modify_tabs' );
	}
}

endif;


/**
 * Triggered inside the Media Library popup to modify the title of the "Gallery" tab.
 */

if ( ! function_exists( 'optionsframework_mlu_modify_tabs' ) ) :

function optionsframework_mlu_modify_tabs ( $tabs ) {
	$tabs['gallery'] = str_replace( __( 'Gallery', 'optionsframework' ), __( 'Previously Uploaded', 'options_framework_theme' ), $tabs['gallery'] );
	return $tabs;
}

endif;